#ifndef R2C2_3D_VEHICLE_H_
#define R2C2_3D_VEHICLE_H_

#include <msp/gl/objectinstance.h>
#include <msp/gl/renderable.h>
#include "libr2c2/vehicle.h"
#include "object.h"

namespace R2C2 {

class VehiclePart3D;
class VehicleType3D;

class Vehicle3D: public Object3D, public Msp::GL::ObjectInstance
{
private:
	Vehicle &vehicle;
	const VehicleType3D &type;
	std::vector<VehiclePart3D *> children;

public:
	Vehicle3D(Layout3D &, Vehicle &);
	~Vehicle3D();

	Vehicle &get_vehicle() const { return vehicle; }
	const VehicleType3D &get_type() const { return type; }

	virtual Vector get_node() const;
	virtual bool is_visible() const;
private:
	virtual void moved();

public:
	virtual void render(Msp::GL::Renderer &, const Msp::GL::Tag &) const;
	virtual void setup_render(Msp::GL::Renderer &, const Msp::GL::Tag &) const;
};

} // namespace R2C2

#endif
