#ifndef PLACEMENTGHOST_H_
#define PLACEMENTGHOST_H_

#include <msp/gl/mesh.h>
#include <msp/gl/object.h>
#include <msp/gl/renderable.h>
#include "libr2c2/vehicleplacement.h"
#include "3d/layout.h"

class PlacementGhost: public Msp::GL::Renderable
{
private:
	R2C2::Layout3D &layout;
	const R2C2::VehicleType &type;
	R2C2::VehiclePlacement placement;
	Msp::GL::Mesh *mesh;
	Msp::GL::Object *object;

public:
	PlacementGhost(R2C2::Layout3D &, const R2C2::VehicleType &);
	virtual ~PlacementGhost();

	void place(const R2C2::TrackOffsetIter &);
	void place_before(const PlacementGhost &);

	virtual void render(Msp::GL::Renderer &, const Msp::GL::Tag &) const;
};

#endif
